//----------------------------------------------------------------------
//This is the HLSL intrinsic function translation for vertex shaders (no textures)
//
//Author - Michal Valient
//Copyright (C) 2004 Caligari corporation
//
//----------------------------------------------------------------------

#ifdef rtx_Ddx
    #undef rtx_Ddx
#endif
#ifdef rtx_Ddy
    #undef rtx_Ddy
#endif
#ifdef rtx_Tex1D
    #undef rtx_Tex1D
#endif
#ifdef rtx_Tex1DProj
    #undef rtx_Tex1DProj
#endif
#ifdef rtx_Tex1DBias
    #undef rtx_Tex1DBias
#endif
#ifdef rtx_Tex2D
    #undef rtx_Tex2D
#endif
#ifdef rtx_Tex2DProj
    #undef rtx_Tex2DProj
#endif
#ifdef rtx_Tex2DBias
    #undef rtx_Tex2DBias
#endif
    #ifdef rtx_Tex3D
#undef rtx_Tex3D
    #endif
#ifdef rtx_Tex3DProj
    #undef rtx_Tex3DProj
#endif
#ifdef rtx_Tex3DBias
    #undef rtx_Tex3DBias
#endif
#ifdef rtx_TexCUBE
    #undef rtx_TexCUBE
#endif
#ifdef rtx_TexCUBEProj
    #undef rtx_TexCUBEProj
#endif
#ifdef rtx_TexCUBEBias
    #undef rtx_TexCUBEBias
#endif

#ifdef ddx
    #undef ddx
#endif
#ifdef ddy
    #undef ddy
#endif
#ifdef tex1D
    #undef tex1D
#endif
#ifdef tex1Dproj
    #undef tex1Dproj
#endif
#ifdef tex1Dbias
    #undef tex1Dbias
#endif
#ifdef tex2D
    #undef tex2D
#endif
#ifdef tex2Dproj
    #undef tex2Dproj
#endif
#ifdef tex2Dbias
    #undef tex2Dbias
#endif
#ifdef tex3D
    #undef tex3D
#endif
#ifdef tex3Dproj
    #undef tex3Dproj
#endif
#ifdef tex3Dbias
    #undef tex3Dbias
#endif
#ifdef texCUBE
    #undef texCUBE
#endif
#ifdef texCUBEproj
    #undef texCUBEproj
#endif
#ifdef texCUBEbias
    #undef texCUBEbias
#endif

#ifdef rtx_CubeNormalize
    #undef rtx_CubeNormalize
#endif

#define rtx_Ddx ddx
#define rtx_Ddy ddy 
#define rtx_Tex1D tex1D
#define rtx_Tex1DProj tex1Dproj
#define rtx_Tex1DBias tex1Dbias
#define rtx_Tex2D tex2D
#define rtx_Tex2DProj tex2Dproj
#define rtx_Tex2DBias tex2Dbias
#define rtx_Tex3D tex3D
#define rtx_Tex3DProj tex3Dproj
#define rtx_Tex3DBias tex3Dbias
#define rtx_TexCUBE texCUBE
#define rtx_TexCUBEProj texCUBEproj
#define rtx_TexCUBEBias texCUBEbias

//CubeMapLookup Normalization core
#ifdef RSD3D_CUBEMAPNORMALIZE
    #define rtx_CubeNormalize(A) (2.0f*texCUBE(smpl_CubeMapNormalization, A).xyz - 1.0f)
#else
    #define rtx_CubeNormalize(A) normalize(A)
#endif
