//----------------------------------------------------------------------
//This is the type definition file for Rosetta Material pipeline types
//
//Author - Michal Valient
//Copyright (C) 2004 Caligari corporation
//
//----------------------------------------------------------------------

#ifndef RSD3DMATERIALFROMME_TYPES_FX_DEFINED
#define RSD3DMATERIALFROMME_TYPES_FX_DEFINED

//Types definition
#define RtFloat float
#define RtFloat3 float3
#define RtFloat4 float4
#define RtFloat3x3 float3x3
#define RtFloat4x4 float4x4
#define RtSampler1D sampler1D
#define RtSampler2D sampler2D
#define RtSampler3D sampler3D
#define RtSamplerCUBE samplerCUBE
#define RtTexture1D texture1D
#define RtTexture2D texture2D
#define RtTexture3D texture3D
#define RtTextureCUBE textureCUBE

//Input definitions
#define RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, VARTYPE, VARTYPESTR) \
VARTYPE VAR : RsD3D_MEInfo < \
    string  Rs_Node = NODE; \
    string  Rs_Connector = CONNECTOR; \
    string  Rs_Type = VARTYPESTR; \
    string  Rs_Usage = USAGE; \
>

//Input definitions
#define RsInput_DefineEx2(VAR, USAGE, VARTYPE) \
VARTYPE VAR : RsD3D_ME2Info < \
    string  Rs_Usage = USAGE; \
>

#define RsInput_RtFloat_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtFloat, "RtFloat")
#define RsInput_RtFloat3_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtFloat3, "RtFloat3")
#define RsInput_RtFloat4_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtFloat4, "RtFloat4")
#define RsInput_RtFloat3x3_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtFloat3x3, "RtFloat3x3")
#define RsInput_RtFloat4x4_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtFloat4x4, "RtFloat4x4")
#define RsInput_RtTexture1D_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtTexture1D, "RtTexture1D")
#define RsInput_RtTexture2D_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtTexture2D, "RtTexture2D")
#define RsInput_RtTexture3D_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtTexture3D, "RtTexture3D")
#define RsInput_RtTextureCUBE_Ex(VAR, NODE, CONNECTOR, USAGE) RsInput_DefineEx(VAR, NODE, CONNECTOR, USAGE, RtTextureCUBE, "RtTextureCUBE")

//New ME versions
#define RsInput_RtFloat_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float)
#define RsInput_RtFloat3_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float3)
#define RsInput_RtFloat4_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float4)
#define RsInput_RtFloat3x3_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float3x3)
#define RsInput_RtFloat4x4_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float4x4)
#define RsInput_RtTexture1D_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, texture1D)
#define RsInput_RtTexture2D_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, texture2D)
#define RsInput_RtTexture3D_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, texture3D)
#define RsInput_RtTextureCUBE_Ex2(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, textureCUBE)

#define RsInput_RtFloat(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float)
#define RsInput_RtFloat3(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float3)
#define RsInput_RtFloat4(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float4)
#define RsInput_RtFloat3x3(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float3x3)
#define RsInput_RtFloat4x4(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, float4x4)
#define RsInput_RtTexture1D(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, texture1D)
#define RsInput_RtTexture2D(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, texture2D)
#define RsInput_RtTexture3D(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, texture3D)
#define RsInput_RtTextureCUBE(VAR, USAGE) RsInput_DefineEx2(VAR, USAGE, textureCUBE)

#define RsInput_RtSampler1D(VAR, VAR_TEX, PARA_MinFilter, PARA_MagFilter, PARA_MipFilter, PARA_AddressU, PARA_BorderColor, PARA_MaxAnisotropy, PARA_MipMapLODBias, PARA_MaxMipLevel) \
sampler1D VAR = sampler_state { \
    Texture = <VAR_TEX>; \
    MinFilter = PARA_MinFilter; \
    MagFilter = PARA_MagFilter; \
    MipFilter = PARA_MipFilter; \
    AddressU = PARA_AddressU; \
    BorderColor = PARA_BorderColor; \
    MaxAnisotropy = PARA_MaxAnisotropy; \
    MipMapLODBias = PARA_MipMapLODBias; \
    MaxMipLevel = PARA_MaxMipLevel; \
}

#define RsInput_RtSampler2D(VAR, VAR_TEX, PARA_MinFilter, PARA_MagFilter, PARA_MipFilter, PARA_AddressU, PARA_AddressV, PARA_BorderColor, PARA_MaxAnisotropy, PARA_MipMapLODBias, PARA_MaxMipLevel) \
sampler2D VAR = sampler_state { \
    Texture = <VAR_TEX>; \
    MinFilter = PARA_MinFilter; \
    MagFilter = PARA_MagFilter; \
    MipFilter = PARA_MipFilter; \
    AddressU = PARA_AddressU; \
    AddressV = PARA_AddressV; \
    BorderColor = PARA_BorderColor; \
    MaxAnisotropy = PARA_MaxAnisotropy; \
    MipMapLODBias = PARA_MipMapLODBias; \
    MaxMipLevel = PARA_MaxMipLevel; \
}

#define RsInput_RtSampler3D(VAR, VAR_TEX, PARA_MinFilter, PARA_MagFilter, PARA_MipFilter, PARA_AddressU, PARA_AddressV, PARA_AddressW, PARA_BorderColor, PARA_MaxAnisotropy, PARA_MipMapLODBias, PARA_MaxMipLevel) \
sampler3D VAR = sampler_state { \
    Texture = <VAR_TEX>; \
    MinFilter = PARA_MinFilter; \
    MagFilter = PARA_MagFilter; \
    MipFilter = PARA_MipFilter; \
    AddressU = PARA_AddressU; \
    AddressV = PARA_AddressV; \
    AddressW = PARA_AddressW; \
    BorderColor = PARA_BorderColor; \
    MaxAnisotropy = PARA_MaxAnisotropy; \
    MipMapLODBias = PARA_MipMapLODBias; \
    MaxMipLevel = PARA_MaxMipLevel; \
}

#define RsInput_RtSamplerCUBE(VAR, VAR_TEX, PARA_MinFilter, PARA_MagFilter, PARA_MipFilter, PARA_AddressU, PARA_AddressV, PARA_AddressW, PARA_BorderColor, PARA_MaxAnisotropy, PARA_MipMapLODBias, PARA_MaxMipLevel) \
samplerCUBE VAR = sampler_state { \
    Texture = <VAR_TEX>; \
    MinFilter = PARA_MinFilter; \
    MagFilter = PARA_MagFilter; \
    MipFilter = PARA_MipFilter; \
    AddressU = PARA_AddressU; \
    AddressV = PARA_AddressV; \
    AddressW = PARA_AddressW; \
    BorderColor = PARA_BorderColor; \
    MaxAnisotropy = PARA_MaxAnisotropy; \
    MipMapLODBias = PARA_MipMapLODBias; \
    MaxMipLevel = PARA_MaxMipLevel; \
}

#define RsInput_RtSampler1D_Lite(VAR, VAR_TEX) \
    RsInput_RtSampler1D(VAR, VAR_TEX, LINEAR, LINEAR, LINEAR, CLAMP, 0, 1, 0, 0)

#define RsInput_RtSampler2D_Lite(VAR, VAR_TEX) \
    RsInput_RtSampler2D(VAR, VAR_TEX, LINEAR, LINEAR, LINEAR, CLAMP, CLAMP, 0, 1, 0, 0)

#define RsInput_RtSampler3D_Lite(VAR, VAR_TEX) \
    RsInput_RtSampler3D(VAR, VAR_TEX, LINEAR, LINEAR, LINEAR, CLAMP, CLAMP, CLAMP, 0, 1, 0, 0)

#define RsInput_RtSamplerCUBE_Lite(VAR, VAR_TEX) \
    RsInput_RtSamplerCUBE(VAR, VAR_TEX, LINEAR, LINEAR, LINEAR, CLAMP, CLAMP, CLAMP, 0, 1, 0, 0)

//RsDefineXXX macros
#define RsDefine_RtFloat(VAR)       float VAR = 1
#define RsDefine_RtFloat3(VAR)      float3 VAR = {1,1,1}
#define RsDefine_RtFloat4(VAR)      float4 VAR = {1,1,1,1}
#define RsDefine_RtFloat3x3(VAR)    float3x3 VAR = {1,0,0, 0,1,0, 0,0,1}
#define RsDefine_RtFloat4x4(VAR)    float4x4 VAR = {1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1}
#define RsDefine_RsFShaderIn(VAR)   RsFShaderIn VAR = input;

//RsConvertXXX macros
#define RsConvert_RtFloat_RtFloat(DST, SRC)       DST = SRC
#define RsConvert_RtFloat_RtFloat3(DST, SRC)      DST = SRC.x
#define RsConvert_RtFloat_RtFloat4(DST, SRC)      DST = SRC.x
#define RsConvert_RtFloat_RtFloat3x3(DST, SRC)    DST = SRC[0].x
#define RsConvert_RtFloat_RtFloat4x4(DST, SRC)    DST = SRC[0].x

#define RsConvert_RtFloat3_RtFloat(DST, SRC)       DST = SRC
#define RsConvert_RtFloat3_RtFloat3(DST, SRC)      DST = SRC
#define RsConvert_RtFloat3_RtFloat4(DST, SRC)      DST = SRC.xyz
#define RsConvert_RtFloat3_RtFloat3x3(DST, SRC)    DST = SRC[0]
#define RsConvert_RtFloat3_RtFloat4x4(DST, SRC)    DST = SRC[0].xyz

#define RsConvert_RtFloat4_RtFloat(DST, SRC)       DST = SRC
#define RsConvert_RtFloat4_RtFloat3(DST, SRC)      {DST.xyz = SRC.xyz; DST.w = 0;}
#define RsConvert_RtFloat4_RtFloat4(DST, SRC)      DST = SRC
#define RsConvert_RtFloat4_RtFloat3x3(DST, SRC)    {DST.xyz = SRC[0].xyz; DST.w = 0;}
#define RsConvert_RtFloat4_RtFloat4x4(DST, SRC)    DST = SRC[0]

#define RsConvert_RtFloat3x3_RtFloat(DST, SRC)       DST = SRC
#define RsConvert_RtFloat3x3_RtFloat3(DST, SRC)      {DST[0] = SRC; DST[1] = SRC; DST[2] = SRC;}
#define RsConvert_RtFloat3x3_RtFloat4(DST, SRC)      {DST[0] = SRC.xyz; DST[1] = SRC.xyz; DST[2] = SRC.xyz;}
#define RsConvert_RtFloat3x3_RtFloat3x3(DST, SRC)    DST = SRC
#define RsConvert_RtFloat3x3_RtFloat4x4(DST, SRC)    {DST[0] = SRC[0].xyz; DST[1] = SRC[1].xyz; DST[2] = SRC[2].xyz;}

#define RsConvert_RtFloat4x4_RtFloat(DST, SRC)       DST = SRC
#define RsConvert_RtFloat4x4_RtFloat3(DST, SRC)      {DST[0].xyz = SRC.xyz; DST[1].xyz = SRC.xyz; DST[2].xyz = SRC.xyz; DST[3].xyz = SRC.xyz; DST[0].w = 0; DST[1].w = 0; DST[2].w = 0; DST[3].w = 0;}
#define RsConvert_RtFloat4x4_RtFloat4(DST, SRC)      {DST[0] = SRC; DST[1] = SRC; DST[2] = SRC; DST[3] = SRC;}
#define RsConvert_RtFloat4x4_RtFloat3x3(DST, SRC)    {DST[0].xyz = SRC[0].xyz; DST[1].xyz = SRC[1].xyz; DST[2].xyz = SRC[2].xyz; DST[0].w = 0; DST[1].w = 0; DST[2].w = 0; DST[3] = float4(0,0,0,1);}
#define RsConvert_RtFloat4x4_RtFloat4x4(DST, SRC)    DST = SRC

#endif //RSD3DMATERIALFROMME_TYPES_FX_DEFINED
